#UTILITY FOR UPGRADING FROM WEBTEACHER'S WEBDATA 2.26 OR 2.27 TO 2.28
#ALWAYS BACKUP YOUR CGI SCRIPTS BEFORE UPGRADING.
#TO USE, UPLOAD THE NEW WEBDATA.CGI AND UPGRADE.PL SCRIPTS
#TO YOUR EXISTING WEBDATA DIRECTORY.  THEN TELNET TO THAT DIRECTORY
#AND TYPE:
#    perl upgrade.pl [scriptname]
#FOR EXAMPLE, IF MY CGI SCRIPT WAS NAMED "webdata_cars.cgi" THEN I
#WOULD TYPE:
#    perl upgrade.pl webdata_cars.cgi


$file=$ARGV[0];
open (OLDFILE,"<$file");
@lines=<OLDFILE>;
close OLDFILE;

if ($lines[1]!~/2.2[6|7|8]/) {
    print "This upgrade program is only tested for version 2.26 and later.
To upgrade from an earlier version:
1.  Backup all of your *.log files.
2.  Run the new installer in the same directory with the same name.
3.  Restore the *.log files.
    ";
    exit;
};

open (BACKUP,">$file\.bak") or die "Could create backup. Make sure current directory has write permission\n";
print BACKUP (@lines);
close BACKUP;

open (NEWFILE,"<webdata.cgi") or die "could not open webdata.cgi, make sure it is in the directory and lower case";
@newlines=<NEWFILE>;
close NEWFILE;

#set 1st 17 lines into @userprefs array

for ($i=0;$i<17;$i++) {
    $newlines[$i]=$lines[$i];
};
$newlines[1]="#version 2.28a\n";

foreach (@lines) {
    if (/FLAG[1-5]/) {push(@flags,$_)};
};

$count=0;
foreach (@newlines) {
    if (/FLAG[1-5]/) {
        $_=$flags[$count];
        $count++;
    };
};

open (MAKEFILE,">$file") or die "Could not overwrite $file, make sure write permissions are turned on.\n";
print MAKEFILE (@newlines);
close MAKEFILE;

print "Upgrade complete.  You will now need to log in as administrator 
and go to the \"Customize Pages\" screen to select which fields appear 
on the user search form.\n\n\n";